//ver 0.1 7 Nov, 2008. (c) SOC Robotics, Inc, BR

#ifndef _I2C_BITBANGED_H_
#define _I2C_BITBANGED_H_

	/* Includes: */
		#include <avr/io.h>
		#include <avr/wdt.h>
		#include <avr/interrupt.h>



void I2C_Init(void);
uint8_t I2C_Write(uint8_t address, uint8_t *data, uint16_t lenght);
uint8_t I2C_Read(uint8_t address, uint8_t *data, uint16_t lenght);
uint8_t I2C_Get_ACK(void);
uint8_t I2C_Send_Byte(uint8_t data);
void I2C_Send_ACK(void);

void I2C_Send_NACK(void);
uint8_t I2C_Receive_Byte(void);
void I2C_Start(void);
void I2C_Stop(void);
void I2C_RepeatedStart(void);
uint8_t I2C_Pulse_SCL_After_ACK(void);
void I2C_Pulse_SCL(void);

void Delay(uint8_t);

extern volatile uint8_t I2C_Port;






#endif
